﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace WpfApplication2
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		public Window1()
		{
			InitializeComponent();
			this.treeView1.AddHandler(FrameworkElement.KeyDownEvent, new KeyEventHandler(RadTreeView_KeyDown), true);
		}

		private void RadTreeView_PreviewSelected(object sender, Telerik.Windows.RadRoutedEventArgs e)
		{
			//(e.OriginalSource as RadTreeViewItem).CheckState = System.Windows.Automation.ToggleState.On;
			//(e.OriginalSource as RadTreeViewItem).Focus();
			//e.Handled = true;
		}

		private void RadTreeView_PreviewCollapsed(object sender, Telerik.Windows.RadRoutedEventArgs e)
		{
			e.Handled = true;
		}
		bool keySelection;
		private void RadTreeView_KeyDown(object sender, KeyEventArgs e)
		{
			keySelection = true;
			if (e.Key == Key.Enter)
			{
				this.ChangeCheckState();
			}
		}

		private void ChangeCheckState()
		{
			RadTreeViewItem selectedItem = this.treeView1.SelectedItem as RadTreeViewItem;
			if (selectedItem.CheckState == System.Windows.Automation.ToggleState.On)
			{
				selectedItem.CheckState = System.Windows.Automation.ToggleState.Off;
			}
			else if (selectedItem.CheckState == System.Windows.Automation.ToggleState.Off)
			{
				selectedItem.CheckState = System.Windows.Automation.ToggleState.On;
			}
		}

		private void treeView1_Selected(object sender, Telerik.Windows.RadRoutedEventArgs e)
		{
			Dispatcher.BeginInvoke(new Action(() =>
			{
				if (!this.keySelection)
				{
					this.ChangeCheckState();
				}
			}), System.Windows.Threading.DispatcherPriority.ApplicationIdle);
		}

	}
}
